var config = {
    remoteurl : "http://app.luyint.com/", 
    //远程请求地址，"http://all.t.com/XinYuXiaoRenTong/index.php"，则填写"http://all.t.com/XinYuXiaoRenTong/"
    //"remoteurl": "http://192.168.1.170/dianzishenfenzheng/", //远程请求地址，"http://127.0.0.1/www/YunLongHuApp/index.php"，则填写"http://127.0.0.1/www/YunLongHuApp/"
    "debug": false, //调试模式下会显示一个调试信息
};

function log( msg ) {
    var appVersion = db2.getVal( "appVersion" );
    if ( config[ "debug" ] == true && appVersion.indexOf( "00.00." ) >= 0 ) {
        console.log( msg );
    }
}


//单地址转绝对地址（转成含有域名的地址）
function toAbsUrl( locationstring, isnocache ) {
    //log("Img2Abs->"+locationstring);
    if ( !locationstring ) {
        return locationstring;
    }
    if ( locationstring.indexOf( "http" ) < 0 ) {
        locationstring = locationstring.replace( "./", "" );
        var remateurl = config[ "remoteurl" ] + locationstring;

        if ( isset( isnocache ) == true ) {
            api.imageCache( { //缓存图片
                url: remateurl
            }, function( ret, err ) {
                //log(JSON.stringify(ret));
                //return ret.url + ".jpg";
            } );
        }

        //好像过多的图片会造成ios 闪退

        return remateurl;
    } else {
        return locationstring;
    }
}

//首页启动里初始化,api已经初始化时调用
function appinit() {
    //将加密数据载入本地库里
    api.loadSecureValue( {
        key: 'token'
    }, function( ret, err ) {
        db2.setVal( "token", ret.value );
    } );
    db2.setVal( "runApptimestamp", ( new Date() ).valueOf() ); //每次运行APP都不同
    checkUpdateTipsOpenStatus( "hide" );
    db2.setVal( "appVersion", api.appVersion );
    //设置iOS头部为
    api.setStatusBarStyle({
        style: 'light'
    });
    db.init();
}
//如：openWin("a", "h=250&w=200")
//openWin("https://item.taobao.com/item.htm?spm=a21hy.85651.390164.1.9gNH2U&id=534001653335")
function openWin( name, pageParam, slidBackEnabled ) {
    var oldname = name;
    var res = {};
    if ( pageParam && pageParam != "" && typeof pageParam != undefined ) {
        var string = pageParam.split( '&' );
        for ( var i = 0; i < string.length; i++ ) {
            var str = string[ i ].split( '=' );
            res[ str[ 0 ] ] = str[ 1 ];
        }
    }
    var url = name;
    if ( url.indexOf( "http" ) < 0 ) {
        if ( url.indexOf( ".html" ) < 0 ) {
            url += ".html";
        }
    } else {
        url = "browser.html";
        //alert(res);
        res[ "urls" ] = name;
        //res= {urls: name};
    }
    slidBackEnabled = typeof slidBackEnabled != "undefined" ? slidBackEnabled : true;
    //log( "slidBackEnabled=>" + slidBackEnabled );
    //var windowname = oldname + ( isset( pageParam ) ? pageParam : "" );
    var windowname = oldname;
    //log( "Open Windows->name:'" + windowname + "';'pageParam'=>" + pageParam );
    api.openWin( {
        name: windowname,
        url: url,
        vScrollBarEnabled: false,
        hScrollBarEnabled: false,
        slidBackEnabled: slidBackEnabled, //默认开启
        bgColor: 'rgba(0,0,0,0.0)',
        animation: {
            type: "push", //动画类型（详见动画类型常量）
            subType: "from_right", //动画子类型（详见动画子类型常量）
            duration: 300 //动画过渡时间，默认300毫秒
        },
        rect: {
            x: 0,
            y: 0
        },
        pageParam: res
    } );
}

//调用系统的分享功能
//share({text:"要分享的文字",type:"text"})
function share( jsonobj ) {
    api.showProgress( {
        title: "创建分享",
        model: 0
    } );
    var sharedModule = api.require( 'shareAction' );
    //  var sharedMsg = {
    //      text : jsonobj.text,
    //      type : typeof(jsonobjtype)=="undefined" ? "text" :jsonobj.type
    //  };
    //alert(JSON.stringify(sharedMsg));
    sharedModule.share( jsonobj );
    api.hideProgress();
}
var mask;
//app 公用函数
var PubApp = {
        //分享到微信好友
        "share": function() {
            //share_title,share_desc,share_pic,share_url;已经在页面有了
            var shareHtml = "";
            shareHtml += '<div class="share_box" id="share_box" style="display: none">';
            shareHtml += '    <div class="detail_like">';
            shareHtml += '        <span class="line left">';
            shareHtml += '        </span>';
            shareHtml += '        <span class="txt">';
            shareHtml += '            分享到';
            shareHtml += '        </span>';
            shareHtml += '        <span class="line right">';
            shareHtml += '        </span>';
            shareHtml += '    </div>';
            shareHtml += '    <div class="share_way clearfix">';
            shareHtml += '        <ul>';
            shareHtml += '            <li>';
            shareHtml += '                <div class="item" id="weixin" style="background-image:url(../css/images/weixin.png)">';
            shareHtml += '                </div>';
            shareHtml += '            </li>';
            shareHtml += '            <li>';
            shareHtml += '                <div class="item" id="pengyouquan" style="background-image:url(../css/images/pengyouquan.png)">';
            shareHtml += '                </div>';
            shareHtml += '            </li>';
            shareHtml += '            <li>';
            shareHtml += '                <div class="item" id="weibo" style="background-image:url(../css/images/weibo.png)">';
            shareHtml += '                </div>';
            shareHtml += '            </li>';
            shareHtml += '            <li>';
            shareHtml += '                <div class="item" id="qq" style="background-image:url(../css/images/qq.png)">';
            shareHtml += '                </div>';
            shareHtml += '            </li>';
            shareHtml += '            <li>';
            shareHtml += '                <div class="item" id="fx" style="background-image:url(../css/images/fx.png)">';
            shareHtml += '                </div>';
            shareHtml += '            </li>';
            shareHtml += '        </ul>';
            shareHtml += '    </div>';
            shareHtml += '    <div class="cancel" tapmode="hover" onclick="$(\'#share_box\').hide();mask.close();">';
            shareHtml += '        取消';
            shareHtml += '    </div>';
            shareHtml += '</div>';
            $( "#share_box" ).remove();
            $( "body" ).append( shareHtml );
            mask = mui.createMask( function() {
                //mask.close();//关闭遮罩
                $( "#share_box" ).hide();
            } ); //callback为用户点击蒙版时自动执行的回调；
            mask.show(); //显示遮罩
            $( "#share_box" ).show();
            //绑定事件
            mui( "#share_box" ).on( 'tap', '.item', function() {
                    //获取id
                    var id = this.getAttribute( "id" );
                    //PubApp.toast(id);
                    switch ( id ) {
                        case "weixin": //微信好友
                            var wx = api.require( 'wx' );

                            share_pic = share_pic.replace( "./", "" );
                            var remateurl = config[ "remoteurl" ] + share_pic;

                            api.imageCache( { //缓存图片
                                url: remateurl
                            }, function( ret, err ) {

                                wx.shareWebpage( {
                                    scene: 'session',
                                    title: share_title,
                                    description: share_desc,
                                    thumb: ret.url,
                                    contentUrl: share_url
                                }, function( ret, err ) {
                                    $( '#share_box' ).hide();
                                    mask.close();
                                    if ( ret.status ) {
                                        //alert('分享成功');
                                    } else {
                                        alert( JSON.stringify( ret ) );
                                    }

                                } );

                                log( JSON.stringify( ret ) );
                                //return ret.url + ".jpg";
                            } );


                            break;
                        case "pengyouquan": //微信朋友圈
                            var wx = api.require( 'wx' );

                            share_pic = share_pic.replace( "./", "" );
                            var remateurl = config[ "remoteurl" ] + share_pic;

                            api.imageCache( { //缓存图片
                                url: remateurl
                            }, function( ret, err ) {

                                wx.shareWebpage( {
                                    scene: 'timeline',
                                    title: share_title,
                                    description: share_desc,
                                    thumb: ret.url,
                                    contentUrl: share_url
                                }, function( ret, err ) {
                                    $( '#share_box' ).hide();
                                    mask.close();
                                    if ( ret.status ) {
                                        //alert('分享成功');
                                    } else {
                                        alert( err.code );
                                    }
                                } );

                                //log(JSON.stringify(ret));
                                //return ret.url + ".jpg";
                            } );

                            break;
                        case "weibo": //微博

                            var weibo = api.require( 'weibo' );
                            share_pic = share_pic.replace( "./", "" );
                            var remateurl = config[ "remoteurl" ] + share_pic;


                            api.imageCache( { //缓存图片
                                url: remateurl
                            }, function( ret, err ) {


                                weibo.shareWebPage( {
                                    text: share_desc,
                                    title: share_title,
                                    description: share_desc,
                                    thumb: ret.url,
                                    contentUrl: share_url
                                }, function( ret, err ) {
                                    //if (ret.status) 
                                    {
                                        $( '#share_box' ).hide();
                                        mask.close();
                                    }
                                } );

                                //log(JSON.stringify(ret));
                                //return ret.url + ".jpg";
                            } );



                            break;
                        case "qq":
                            var qq = api.require( 'qq' );
                            qq.shareNews( {
                                url: share_url,
                                title: share_title,
                                description: share_desc,
                                imgUrl: toAbsUrl( share_pic )
                            }, function( ret, err ) {
                                $( '#share_box' ).hide();
                                mask.close();
                            } );

                            break;
                        case "fx":

                            var clipBoard = api.require( 'clipBoard' );
                            clipBoard.set( {
                                value: share_title + share_url
                            }, function( ret, err ) {
                                if ( ret ) {
                                    PubApp.toast( "已经复制!" );
                                } else {
                                    //alert( JSON.stringify( err ) );
                                }
                            } );

                            $( '#share_box' ).hide();
                            mask.close();

                            break;
                    }
                } )
                //__绑定事件
        },
        "toast": function( msg ) {
            api.toast( {
                msg: msg,
                location: 'middle'
            } );
        },
        readCookie: function( name ) {
            var cookieValue = "";

            var search = name + "=";

            if ( document.cookie.length > 0 )

            {

                offset = document.cookie.indexOf( search );

                if ( offset != -1 )

                {

                    offset += search.length;

                    end = document.cookie.indexOf( ";", offset );

                    if ( end == -1 ) end = document.cookie.length;

                    cookieValue = unescape( document.cookie.substring( offset, end ) )

                }

            }

            return cookieValue;
        },
        //writeCookie("myCookie", "my name", 24);
        writeCookie: function( name, value, hours ) {
            var expire = "";
            if ( hours != null ) {
                expire = new Date( ( new Date() ).getTime() + hours * 3600000 );

                expire = "; expires=" + expire.toGMTString();

            }
            document.cookie = name + "=" + escape( value ) + expire;
        },
        clearCookie: function( name ) {
            PubApp.writeCookie( name, "", -1 );
        },
        setCloseBtn: function( befterCloseFun ) {
            //set button
            var btn_back = api.require( 'UIButton' );
            btn_back.open( {
                rect: {
                    x: 0,
                    y: 0,
                    w: 60,
                    h: 44
                },
                bg: {
                    normal: 'rgba(0,0,0,0)',
                    highlight: 'rgba(0,0,0,0)',
                    active: 'rgba(0,0,0,0)',
                },
                fixedOn: api.frameName,
                fixed: true,
                move: false
            }, function( ret, err ) {
                if ( ret ) {
                    if ( ret.eventType == "click" ) {
                        if ( typeof befterCloseFun == "function" ) {
                            befterCloseFun();
                        }
                        api.closeWin();
                    }
                } else {

                }
            } );
            //__set button

            if ( typeof befterCloseFun == "function" ) {
                api.addEventListener( {
                    name: 'keyback'
                }, function( ret, err ) {
                    befterCloseFun();
                    api.closeWin();
                } );
            }



        },
        setLeftBtn: function( befterCloseFun ) {
            //set button
            var btn_back = api.require( 'UIButton' );
            btn_back.open( {
                rect: {
                    x: 0,
                    y: 0,
                    w: 60,
                    h: 44
                },
                bg: {
                    normal: 'rgba(0,0,0,0)',
                    highlight: 'rgba(0,0,0,0)',
                    active: 'rgba(0,0,0,0)',
                },
                fixedOn: api.frameName,
                fixed: true,
                move: false
            }, function( ret, err ) {
                if ( ret ) {
                    if ( ret.eventType == "click" ) {
                        if ( typeof befterCloseFun == "function" ) {
                            befterCloseFun();
                        }
                    }
                } else {

                }
            } );
            //__set button
        },
        setRightBtn: function( AfterClickFun ) {
            //set button
            var btn_back = api.require( 'UIButton' );
            btn_back.open( {
                rect: {
                    x: api.winWidth - 60,
                    y: 0,
                    w: 60,
                    h: 44
                },
                bg: {
                    normal: 'rgba(0,0,0,0)',
                    highlight: 'rgba(0,0,0,0)',
                    active: 'rgba(0,0,0,0)',
                },
                fixedOn: api.frameName,
                fixed: true,
                move: false
            }, function( ret, err ) {
                if ( ret ) {
                    if ( ret.eventType == "click" ) {
                        if ( typeof AfterClickFun == "function" ) {
                            AfterClickFun();
                        }
                    }
                } else {

                }
            } );
            //__set button



        },
        doLogoutFun: function() {
            log( "退出了###################" );
            db2.setVal( "utoken", "null" );
            db2.setVal( "user_uid", "null" );
            db2.setVal( "user_umobile", "null" );
            api.sendEvent( {
                name: 'userloginorout'
            } );
        },
        //退出操作
        doLogout: function() {
            api.confirm( {
                title: '提醒',
                msg: '确认要退出吗？',
                buttons: [ '确定', '取消' ]
            }, function( ret, err ) {
                if ( ret ) {
                    if ( ret.buttonIndex == 1 ) {
                        PubApp.doLogoutFun();
                        api.toast( {
                            msg: '已经退出',
                            duration: 2000,
                            location: 'midden'
                        } );
                        api.closeToWin( {
                            name: 'root',
                            animation: {
                                type: "push", //动画类型（详见动画类型常量）
                                subType: "from_right", //动画子类型（详见动画子类型常量）
                                duration: 300 //动画过渡时间，默认300毫秒
                            }
                        } );
                        return true;
                    } else {
                        return false;
                    }
                } else {
                    alert( JSON.stringify( err ) );
                }
            } );
        },
        //压缩图片；参数：图片路径、指定宽度
        CompressedImg: function( SourcePicPath, targetWidth, fun ) {
            var imageFilter = api.require( 'imageFilter' );
            //正在压缩图片
            imageFilter.getAttr( {
                    path: SourcePicPath
                }, function( ret, err ) {

                    if ( ret.status ) {
                        var cacheDir = api.cacheDir;
                        var kzm = SourcePicPath.substring( SourcePicPath.lastIndexOf( "." ), SourcePicPath.length ); //扩展名
                        var newImgName = new Date().valueOf().toString() + kzm; //新的文件名
                        //log(SourcePicPath);
                        //log(cacheDir+"/"+newImgName);
                        if ( ret.width > targetWidth ) {
                            //PubApp.toast("正在压缩图片");
                            imageFilter.compress( {
                                img: SourcePicPath,
                                quality: api.systemType=="android"?0.9:0.3,
                                size: {
                                    w: targetWidth,
                                    h: Math.ceil( targetWidth * ret.height / ret.width ), //等比的高度
                                },
                                save: {
                                    imgPath: cacheDir,
                                    imgName: newImgName
                                }
                            }, function( ret, err ) {
                                //alert(JSON.stringify(ret));
                                if ( ret.status ) {
                                    SourcePicPath = cacheDir + "/" + newImgName; //新的路径
                                    fun( SourcePicPath ); //回掉函数
                                } else {
                                    alert( JSON.stringify( err ) );
                                }
                            } );
                        } else {
                            fun( SourcePicPath ); //回掉函数
                        }
                    }
                } )
                //__正在压缩图片
        },
    }
    //直接拨打电话

function tel( mobile ) {
    if ( mobile ) {
        api.call( {
            type: 'tel_prompt',
            number: mobile
        } );
    } else {
        api.toast( {
            msg: '电话号码错误' + mobile
        } );
    }
}
//仅仅是显示图片
//图片集imgjson:"1.jpg,2.jpg"
function showimgzoom( imgjson ) {
    //alert(imgjson);
    var imageBrowser = api.require( 'imageBrowser' );
    imageBrowser.openImages( {
        imageUrls: imgjson.split( "," ),
        showList: false
    } );
    //var photoBrowser = api.require('imageBrowser');
    //  photoBrowser.open({
    //      images: imgjson.split(","),
    //      activeIndex: 0,
    //      placeholderImg: 'widget://res/img/apicloud.png',
    //      bgColor: '#000'
    //  }, function(ret){
    //      //alert(JSON.stringify(ret));
    //      switch (ret.eventType)
    //      {
    //          case "click":
    //              photoBrowser.close();
    //          break;
    //      }
    //  });
}

function uploadimg( filepath, fun ,needproess) {
    if(typeof needproess =="undefined")
    {
        api.showProgress( {
            title: "正在上传",
        } );
    }
    api.ajax( {
        url: config[ 'remoteurl' ] + "index.php?g=Api&m=Index&a=upload",
        method: 'post',
        timeout: 30,
        dataType: 'json',
        returnAll: false,
        data: {
            files: {
                file: filepath
            }
        }
    }, function( ret, err ) {
        api.hideProgress();
        if ( ret ) {
            //log( "上传结果：" + JSON.stringify( ret ) );
            if ( ret[ "status" ] == 0 ) {
                api.toast( {
                    msg: ret[ "info" ],
                    location: 'middle'
                } );
                return false;
            }
            fun( ret[ "data" ] );
            //$(".filewarp:eq(" + uploadbtn_index + ")").append('<span><input type="hidden" name="imgs' + uploadbtn_index + '" value="' + ret["data"] + '" /><img src="' + url + '" /></span><i class="aui-iconfont aui-icon-roundclosefill"></i>');
        } else {
            api.hideProgress();
            api.alert( {
                msg: ( '错误码：' + err.code + '；错误信息：' + err.msg + '网络状态码：' + err.statusCode )
            } );
        }
    } );
}
//获取图片并手动裁剪后的图片地址
//返回图片的file地址
//参数是是回调函数
/**
 * [getImgAndCrop description]
 * @param  {[type]} funs         [回调函数]
 * @param  {[type]} targetWidth  [目标宽度ios有效]
 * @param  {[type]} targetHeight [目标高度ios有效]
 * @return {[type]}              []
 */
function getImgAndCrop( funs, targetWidth, targetHeight ) {
    api.actionSheet( {
        title: '选择图片',
        cancelTitle: '取消',
        //destructiveTitle: '红色警告按钮',
        buttons: [ '拍照', '相册' ]
    }, function( ret, err ) {
        if ( ret ) {
            var sourceType = "camera";
            //alert(ret.buttonIndex);
            if ( ret.buttonIndex == 3 ) { //取消
                return false;
            }
            if ( ret.buttonIndex == 1 ) {
                sourceType = "camera";
            }
            if ( ret.buttonIndex == 2 ) {
                sourceType = "library";
            }
            api.getPicture( {
                sourceType: sourceType,
                encodingType: 'jpg',
                mediaValue: 'pic',
                destinationType: 'url',
                allowEdit: true,
                quality: 100,
                targetWidth: targetWidth,
                targetHeight: targetHeight,
                saveToPhotoAlbum: false
            }, function( ret, err ) {
                if ( ret ) {
                    if ( $api.trim( ret.data ) != "" ) {
                        funs( ret.data );
                    }
                } else {
                    //                          api.alert({
                    //                              msg : err.msg
                    //                          });
                }
            } );
        } else {
            alert( JSON.stringify( err ) );
        }
    } );
}






function isLogin() {
    var utoken = db2.getVal( "utoken" );
    if ( utoken != "" && utoken != null ) {
        //alert("有登陆的的");
        return true;
    } else {
        //alert("已经退出");
        return false;
    }
}






//sqlite,大数据，异步处理
//因官方DB模块不支持内容中含有单引号，so直接使用H5的sqlite
var db = ( function() {
    var fns = {
        //异步的，给打开一点点时间
        "init": function() {
            var db = openDatabase( 'cjhdb', '1.0', 'app db', 1024 * 100 ); //数据库名 版本 数据库描述 大小
            db.transaction( function( tx ) {
                tx.executeSql( 'CREATE TABLE if not exists setconfig(itemname varchar(255), info TEXT)', [], function( tx, err ) {
                    log( "打开库，并执行了创建默认表" );
                } );
            } )
        },
        "getConfig": function( keys, func ) {
            var db = openDatabase( 'cjhdb', '1.0', 'app db', 1024 * 100 ); //数据库名 版本 数据库描述 大小
            db.transaction( function( tx ) {
                tx.executeSql( "SELECT * FROM setconfig where itemname='" + keys + "'", [], function( tx, result ) {
                    if ( result.rows.length == 0 ) {
                        log( "获取缓存【" + keys + "】,但不存在记录哦" );
                        func( "" );
                    } else {
                        var data = result.rows.item( 0 ).info;
                        log( "获得缓存【" + keys + "】值【" + data + "】" );
                        func( data );
                    }
                } )
            } )
        },
        "setConfig": function( keys, vals ) {
            //log("写入参数操作");
            var db = openDatabase( 'cjhdb', '1.0', 'app db', 1024 * 100 ); //数据库名 版本 数据库描述 大小
            db.transaction( function( tx ) {
                tx.executeSql( "delete from setconfig where itemname='" + keys + "'", [], function( tx, result ) {} );
            } )
            if ( vals != null ) {
                db.transaction( function( tx ) {
                    tx.executeSql( "insert into setconfig(itemname,info) values(?,?)", [ keys, vals ], function( tx, result ) {} );
                } )
            }
        }
    }
    return fns;
} )();




function gethtml( msgtext ) {
    if ( msgtext != "" ) {
        msgtext = msgtext.replace( new RegExp( '&lt;', 'gm' ), '<' );
        msgtext = msgtext.replace( new RegExp( '&gt;', 'gm' ), '>' );
        msgtext = msgtext.replace( new RegExp( '&quot;', 'gm' ), '"' );
        msgtext = msgtext.replace( new RegExp( '&2339;', 'gm' ), '\'' );
    }
    return msgtext;
}
//localStorage,常规数库，Html5支持,限5M，适合常规固定小数据
var db2 = ( function() {
    var fns = {
        "getVal": function( keys ) {
            if ( !window.localStorage.getItem( keys ) ) window.localStorage.setItem( keys, "" );
            return window.localStorage.getItem( keys );
            //return PubApp.readCookie(keys);
        },
        "setVal": function( keys, vals ) {

            window.localStorage.removeItem( keys );
            //在iPhone/iPad上有时设置setItem()时会出现诡异的QUOTA_EXCEEDED_ERR错误，这时一般在setItem之前，先removeItem()就ok了。
            if ( vals != null && vals != "null" ) {
                window.localStorage.setItem( keys, vals );
            }

            // PubApp.clearCookie(keys);
            // if (vals != null && vals != "null") {
            //     PubApp.writeCookie(keys,vals,24*365);
            // }
        },
        "reset": function() {
            window.localStorage.clear();
        }
    };
    return fns;
} )();



//封装请求的URL，参数：m为Thinkphp 的modle,a为action
//如:http://192.168.1.115/XinYuXiaoRenTong/index.php?s=Dl&m=Student&a=getabcd
function getJiaMi( m, a ) {
    var times = new Date().getTime();
    var rnds = Math.ceil( Math.random() * 9999999999999 );
    var token = md5( md5( md5( db2.getVal( "token" ) ) ) + md5( times + "" + rnds + "" + db2.getVal( "token" ) ) );
    //封装URL
    if ( m == "" ) alert( "URL参数m错误" );
    if ( a == "" ) alert( "URL参数a错误" );
    if ( typeof config == "undefined" ) alert( "未导入配置config.js" );
    if ( typeof db2.getVal( "token" ) == "undefined" || db2.getVal( "token" ) == "" || db2.getVal( "token" ) == null ) alert( "db2 中获取 token失败" );
    if ( typeof config[ 'remoteurl' ] == "undefined" ) alert( "remoteurl未设置" );
    var baseurl = config[ 'remoteurl' ] + "index.php?g=Api&m=" + m + "&a=" + a;
    return {
        times: times,
        rnds: rnds,
        token: token,
        baseurl: baseurl
    };
}
//二次封装doajax，加入当前会员账号信息,即服务器验证要求用户已经登陆才可操作
function doAjaxByUser( m, a, get, getOrPost, fun ) {
    //此处封装下utoken
    var currenttime = new Date().getTime();
    //var newutoken = md5(md5(db2.getVal("user_utoken") + "" + md5(db2.getVal("user_uid"))) + "" + md5(currenttime));
    doAjax( m, a, "currentUserId=" + db2.getVal( "user_uid" ) + "&currenttime=" + currenttime + "&" + get, getOrPost, fun );
}
//ajax的再次封装，支持输出提交的url
//操作模块，操作名，传递参数（字符串格式）,get或post，回调函数funs(data)
var neterrorlimit = true;
var isCanContactNet = true;

function returnSkipCheckUpdate() {
    //判断本次运行是否提现过了
    var isTipsendMark = db2.getVal( "runApptimestamp" ) + "isSelectSkipUpdate";
    if ( isset( db2.getVal( isTipsendMark ) ) ) //用户选择本次跳过更新
    {
        return "&skipversion=1";
    } else {
        return "";
    }
}

function doAjax( m, a, get, getOrPost, fun ) {
    if ( isCanContactNet == false ) return false;
    var jm = getJiaMi( m, a );
    var getstr = "";
    if ( getOrPost == "" || getOrPost.toLocaleLowerCase() == "get" ) //采用get提交
    {
        getOrPost = "get";
        var urls = jm.baseurl + "&token=" + jm.token + "&times=" + jm.times + "&rnds=" + jm.rnds + "&appversion=" + api.appVersion + "&appos=" + api.systemType + "&appimei=" + api.deviceId + "&" + get + returnSkipCheckUpdate() + "&currentUserToken=" + db2.getVal( "utoken" );
    } else //采用POST提交
    {
        var urls = jm.baseurl;
        getstr = "token=" + jm.token + "&times=" + jm.times + "&rnds=" + jm.rnds + "&appversion=" + api.appVersion + "&appos=" + api.systemType + "&appimei=" + api.deviceId + "&" + get + returnSkipCheckUpdate() + "&currentUserToken=" + db2.getVal( "utoken" );
    }
    //__装装URL
    log( "Ajax(" + getOrPost + "):" + urls + "&" + getstr );
    if ( getOrPost == "post" ) {
        var string = getstr.split( '&' );
        var res = {};
        for ( var i = 0; i < string.length; i++ ) {
            var str = string[ i ].split( '=' );
            res[ str[ 0 ] ] = str[ 1 ];
        }
        //alert(getstr);
    }
    api.ajax( {
        url: urls,
        method: getOrPost,
        timeout: 30,
        dataType: 'json',
        returnAll: false,
        data: {
            values: res
        },
    }, function( retsystem, err ) {
        //log("Ajax->"+JSON.stringify(ret));
        if ( retsystem ) {
            //var urlJson = JSON.stringify(ret);
            //api.alert({msg: urlJson});
            if ( isset( retsystem.status ) ) {
                var requeststatus = Number( retsystem.status );
                if ( requeststatus <= -1000 ) {
                    api.hideProgress();
                    api.refreshHeaderLoadDone();
                    if ( requeststatus >= -2000 ) { //-1~-1999
                        api.toast( {
                            msg: retsystem.info,
                            location: 'midden'
                        } );
                        if ( requeststatus == -1002 ) //Token错误
                        {
                            PubApp.doLogoutFun(); //强行退出
                        }
                    } else if ( requeststatus >= -3000 ) //-3000~-2000,版本问题
                    {
                        if ( checkUpdateTipsOpenStatus() == 'hide' ) { //防止跳出多个
                            if ( requeststatus == -2001 ) //提醒升级
                            {
                                doUpdateApp( retsystem, false );
                            } else if ( requeststatus == -2002 ) //强制升级
                            {
                                doUpdateApp( retsystem, true );
                            }
                        }
                        //abc
                    }
                } else {
                    fun( retsystem );
                }
            } else //for兼容
            {
                fun( retsystem );
            }
        } else {
            api.toast( {
                //msg : "Ajax:"+err.msg
                msg: err.msg
            } );
            api.hideProgress();
            api.refreshHeaderLoadDone();
            log( "Sys Error:" + err.msg );
            return false;
        }
    } );
}
//提醒升级框状态
//x 为'show','hide'
function checkUpdateTipsOpenStatus( x ) {
    if ( typeof x == "undefined" ) {
        var checkUpdateTipsOpenStatus = db2.getVal( "checkUpdateTipsOpenStatus" );
        if ( checkUpdateTipsOpenStatus == "" ) checkUpdateTipsOpenStatus = "hide";
        return checkUpdateTipsOpenStatus;
    } else {
        db2.setVal( "checkUpdateTipsOpenStatus", x );
    }
}
/**
 * [doUpdateApp description] APP升级
 * @param  {[type]} rs        接口返回的所有JSON数据
 * @param  {[type]} absupdate 是否强制升级true,false
 * @return {[type]}           [description]
 *
 * result={data:{version:2.1,updateTip:'修复部分dug',time:'2016-06-28',time:'2016-06-28',source:'http://www.qq.com/a.apk'}}
 */
function doUpdateApp( result, absupdate ) {

    if ( api.appVersion.indexOf( "00.00" ) == 0 ) {
        //return true;
    }

    if ( absupdate == false ) //非强行升级
    {
        //判断本次运行是否提现过了
        var isTipsendMark = db2.getVal( "runApptimestamp" ) + "isSelectSkipUpdate";
        if ( isset( db2.getVal( isTipsendMark ) ) ) //用户选择本次跳过更新
        {
            return false;
        }
    }
    checkUpdateTipsOpenStatus( "show" );
    var buttons = [ '确定', '取消' ];
    var str = '版本:' + result.data.version + '\r\n更新:' + result.data.updateTip + '\r\n时间:' + result.data.time;
    api.confirm( {
        title: '发现新版本',
        msg: str,
        buttons: buttons
    }, function( ret, err ) {
        checkUpdateTipsOpenStatus( "hide" );
        if ( ret.buttonIndex == 1 ) {
            if ( api.systemType == "android" ) {
                api.download( {
                    url: result.data.source,
                    report: true
                }, function( ret, err ) {
                    if ( ret && 0 == ret.state ) { /* 下载进度 */
                        api.toast( {
                            msg: "正在下载应用" + ret.percent + "%",
                            duration: 2000
                        } );
                    }
                    if ( ret && 1 == ret.state ) { /* 下载完成 */
                        var savePath = ret.savePath;
                        api.installApp( {
                            appUri: savePath
                        } );
                    }
                } );
            }
            if ( api.systemType == "ios" ) {
                api.openApp( {
                    iosUrl: result.data.source, //例如调用系统浏览器Safari打开
                    appParam: {
                        appParam: 'app参数'
                    }
                } );
            }
        } else {
            if ( absupdate == false ) //非强行升级
            {
                var isTipsendMark = db2.getVal( "runApptimestamp" ) + "isSelectSkipUpdate";
                db2.setVal( isTipsendMark, "1" ); //用户选择本次不升级
                log( "用户选择本次不升级" );
                //目的让被阻止的页面刷新下
                api.sendEvent( {
                    name: 'userloginorout'
                } );
            }
        }
    } );
}
/**
 * [isset 模拟php isset]
 * @param  {[type]} obj [description]
 * @return {[type]}   true or false
 */
function isset( obj ) {
    if ( typeof obj == "undefined" ) {
        return false;
    }
    if ( obj == "" ) {
        return false;
    }
    if ( obj == "null" || obj == null ) {
        return false;
    }
    if ( !obj ) {
        return false;
    }
    return true;
}



function _parserUrl( tourl ) //解析URL并转换为json形式
{}

function getLocalTime( nS, formatstyle ) {
    //return new Date(parseInt(nS) * 1000).toLocaleString().replace(/:\d{1,2}$/, ' ');
    var unixTimestamp = new Date( parseInt( ( ( "" + nS ).length > 10 ? nS : nS * 1000 ) ) );
    var m = ( unixTimestamp.getMonth() + 1 );
    if ( m <= 9 ) m = "0" + m;
    var d = ( unixTimestamp.getDate() );
    if ( d <= 9 ) d = "0" + d;
    var h = ( unixTimestamp.getHours() );
    if ( h <= 9 ) h = "0" + h;
    var i = ( unixTimestamp.getMinutes() );
    if ( i <= 9 ) i = "0" + i;
    var s = ( unixTimestamp.getSeconds() );
    if ( s <= 9 ) s = "0" + s;
    if ( typeof formatstyle != "undefined" ) {
        switch ( formatstyle ) {
            case "Y-m-d":
                datas = unixTimestamp.getFullYear() + "-" + m + "-" + d;
                break;
            case "H:i:s":
                datas = h + ":" + i + ":" + s;
                break;
            case "i:s":
                datas = i + ":" + s;
                break;
            case "H:i":
                datas = h + ":" + i;
                break;
            case "H":
                datas = unixTimestamp.getHours();
            case "d":
                datas = unixTimestamp.getDate();
        }
    } else {
        datas = unixTimestamp.getFullYear() + "-" + m + "-" + d + " " + h + ":" + i + ":" + s;
    }
    return datas;
}

var apicloudsignature;

function md5( string ) {
    if ( !apicloudsignature ) {
        apicloudsignature = api.require( 'signature' );
    }
    var value = apicloudsignature.md5Sync( {
        data: string
    } );
    if ( isset( value ) ) {
        return value.toLowerCase();
    } else {
        return "";
    }
}

function GetsystemType() {
    var is_android = ( function() {
        return navigator.userAgent.toLowerCase().indexOf( 'android' ) !== -1
    } )();
    return is_android ? "android" : "ios";
}
